%%%generate the centres from groups of tracklets
%Input:
%GTracklets:cell that contain tracklets, should have the size K
%Rows: duration of all tracks, not the video
%K
%Output: generated Centres
%%%%%%%%%%%%%%%%%%%%
%
% Copyright 2012, Zhen Qin and Christian R. Shelton
% Provided free for non-commercial use
% WITHOUT ANY WARRANTY -- see Readme.txt
function Centres = Centre_Gen_Town(GTracklets,Rows,K,Data,FinishFrame,StartFrame,NumofTr,Tracklet_cell,Width,Height)
    
Centres=zeros(FinishFrame-StartFrame+1,K*2); %the centre mat, Rows* (2K) size, 
     
    for i=1:K %for each cluster   K
        labels=zeros(FinishFrame-StartFrame+1,1);%# of tracklets in one cluster appear in one frame, used to cal the mean trajectory
        tmptracklet= cell2mat(GTracklets(i));
        tmp1=size(tmptracklet,2);
        for j=1:tmp1 %for each tracklet in the cluster    tmp1
            
            datatmp=cell2mat(Tracklet_cell(tmptracklet(j)));
            %tmpnumofdata=size(datatmp,1);
            tmplength = datatmp(2)-datatmp(1)+1;
            tmpstart=datatmp(1)-StartFrame+1;  %%%%%%%%%IMPORTANT!!!%%%%%%%%%
            %tmpfinish=datatmp(2)-StartFrame+1;
            
            for m= 0:1:tmplength-1 %for each timestep in the tracklet  here x
                tmpcx=datatmp(4+m*4);
                tmpframe=tmpstart+m;
                Centres(tmpframe,2*i-1)=Centres(tmpframe,2*i-1)+tmpcx;
                labels(tmpframe)=labels(tmpframe)+1;
            end
            
            for m= 0:1:tmplength-1 %for each timestep in the tracklet  here y
                tmpcy=datatmp(5+m*4);
                tmpframe=tmpstart+m;
                Centres(tmpframe,2*i)=Centres(tmpframe,2*i)+tmpcy;
            end        
        end
        
   
       
        Notzero=find(labels~=0);
        Centres(Notzero,2*i-1)=Centres(Notzero,2*i-1)./labels(Notzero);   %average x
        Centres(Notzero,2*i)=Centres(Notzero,2*i)./labels(Notzero);
        
    end
    
    %Now we get Centres for the clusters Centres, do intropolation and
    %extropolation
    for i=1:K%
        tmp_track = Centres(:,2*i);
        NotZeroLabel=find(tmp_track~=0); 
        if(numel(NotZeroLabel)==0)
            Centres(:,2*i-1)=0;
            Centres(:,2*i)=0;
        else    
        Begin=NotZeroLabel(1);
        Position1=Begin;
        Counter=Begin;
        Iter=1;
        Size=size(NotZeroLabel,1);
        
        while(Counter<=Rows&&Iter<=Size)
              if(find(NotZeroLabel==Counter))
                  Counter=Counter+1;
                  Iter=Iter+1;
              else
                  Position1=[Position1 Counter-1];
                  Counter=NotZeroLabel(Iter);
                  Position1=[Position1 Counter];
                  
                  
              end
        end
        Position1=[Position1 NotZeroLabel(Size)]; %indicate start and finish point of where nonzero
        %%%%do intropolation
        Ind_size=size(Position1,2);
        for m=1:(Ind_size/2-1)
            gap=Position1(2*m+1)-Position1(2*m)+1;
            posx_1=Centres(Position1(2*m),2*i-1); %if i loop K
            posx_2=Centres(Position1(2*m+1),2*i-1);
            rate_x=(posx_2-posx_1)/gap;
            posy_1=Centres(Position1(2*m),2*i); %if i loop K
            posy_2=Centres(Position1(2*m+1),2*i);
            rate_y=(posy_2-posy_1)/gap;
            for l=1:gap
                Centres(Position1(2*m)+l,2*i-1)=Centres(Position1(2*m),2*i-1)+rate_x*l;
                Centres(Position1(2*m)+l,2*i)=Centres(Position1(2*m),2*i)+rate_y*l;
            end
            
        end
        %%%%do extropolation, x and y do at the same time, one get the
        %%%%boundary, stop there and remaining point are the same,use
        %%%%intropolated Centres, use ave vel of first and last 100 frames
        if(Position1(1)~=1) %need to extro backwards
            if(Position1(Ind_size)-Position1(1)>=20)
                extro_start1=Centres(Position1(1),(2*i-1):2*i);
                extro_start2=Centres(Position1(1)+20,(2*i-1):2*i);
            
                extro_rate1=(extro_start2-extro_start1)/20;
            
              %  counter_tmp=Position1(1);   %see where exceeds the figure
                for l=1:Position1(1)-1
                
                    extro_tmp=extro_start1-extro_rate1*l;
                    if(extro_tmp(1)>=1&&extro_tmp(1)<=Width&&extro_tmp(2)>=1&&extro_tmp(2)<=Height) %not exceed
                        Centres(Position1(1)-l,2*i-1)=extro_tmp(1);
                        Centres(Position1(1)-l,2*i)=extro_tmp(2);
                    else
                        Centres(Position1(1)-l,2*i-1)=Centres(Position1(1)-l+1,2*i-1); %exceed
                        Centres(Position1(1)-l,2*i)=Centres(Position1(1)-l+1,2*i);
                    end
                end
            else %<=100
                %disp('cluster too short');
                extro_start1=Centres(Position1(1),(2*i-1):2*i);
                extro_start2=Centres(Position1(Ind_size),(2*i-1):2*i);
            
                extro_rate1=(extro_start2-extro_start1)/(Position1(Ind_size)-Position1(1));
            
                for l=1:Position1(1)-1
                
                    extro_tmp=extro_start1-extro_rate1*l;
                    if(extro_tmp(1)>=1&&extro_tmp(1)<=Width&&extro_tmp(2)>=1&&extro_tmp(2)<=Height) %not exceed
                        Centres(Position1(1)-l,2*i-1)=extro_tmp(1);
                        Centres(Position1(1)-l,2*i)=extro_tmp(2);
                    else
                        Centres(Position1(1)-l,2*i-1)=Centres(Position1(1)-l+1,2*i-1); %exceed
                        Centres(Position1(1)-l,2*i)=Centres(Position1(1)-l+1,2*i);
                    end
                end
                
            end
        
        end  %backward end
                    
        
        
        if(Position1(Ind_size)~=Rows) %need to extro forward
            if(Position1(Ind_size)-Position1(1)>=20)
                extro_finish1=Centres(Position1(Ind_size),(2*i-1):2*i);%last one
                extro_finish2=Centres(Position1(Ind_size)-20,(2*i-1):2*i);
            
                extro_rate2=(extro_finish1-extro_finish2)/20;
            
              %  counter_tmp=Position1(1);   %see where exceeds the figure
                for l=1:Rows-Position1(Ind_size)
                
                    extro_tmp=extro_finish1+extro_rate2*l;
                    if(extro_tmp(1)>=1&&extro_tmp(1)<=Width&&extro_tmp(2)>=1&&extro_tmp(2)<=Height) %not exceed
                        Centres(Position1(Ind_size)+l,2*i-1)=extro_tmp(1);
                        Centres(Position1(Ind_size)+l,2*i)=extro_tmp(2);
                    else
                        Centres(Position1(Ind_size)+l,2*i-1)=Centres(Position1(Ind_size)+l-1,2*i-1); %exceed
                        Centres(Position1(Ind_size)+l,2*i)=Centres(Position1(Ind_size)+l-1,2*i);
                    end
                end
            else %<=100
                %disp('cluster too short');
                extro_finish1=Centres(Position1(1),(2*i-1):2*i);%last one
                extro_finish2=Centres(Position1(Ind_size),(2*i-1):2*i);
            
                extro_rate2=(extro_finish1-extro_finish2)/(Position1(Ind_size)-Position1(1));
            
                for l=1:Rows-Position1(Ind_size)
                
                    extro_tmp=extro_finish1+extro_rate2*l;
                    if(extro_tmp(1)>=1&&extro_tmp(1)<=Width&&extro_tmp(2)>=1&&extro_tmp(2)<=Height) %not exceed
                        Centres(Position1(Ind_size)+l,2*i-1)=extro_tmp(1);
                        Centres(Position1(Ind_size)+l,2*i)=extro_tmp(2);
                    else
                        Centres(Position1(Ind_size)+l,2*i-1)=Centres(Position1(Ind_size)+l-1,2*i-1); %exceed
                        Centres(Position1(Ind_size)+l,2*i)=Centres(Position1(Ind_size)+l-1,2*i);
                    end
                end
                
            end
        
        end  %forward end
        end       
    end
        
    
            
        
        
    
    
    
    
    
    
    
    
    
    
    
    
