function [Centre_new,Assign,distmat]= mykmeans_new(data,Centres,method,StartFrame,NumofTr,K,Rows,Data,u,psi,FinishFrame,WEIGHT,Width,Height)
%function [centers,mincenter,mindist,q2,quality] = mykmeans(data,initcenters,method)
%Input:
%Tracklet_cell  -data
%Centres    -initcenters
%K
%should have u, psi
%StartFrame
%
%output: Centre_new;  cell, G
%Assign: represents phi
%distmat: used to cal the overal score
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%old%%%%%%%%%%%%%%%%%%%%%%%
% output: final centers
% input: data points and initial centers
% if initcenters is a number k, create k centers and start with these
% otherwise, use centers given as input
% method = 0: unoptimized, using n by k matrix of distances O(nk) space
%          1: vectorized, using only O(n+k) space
%          2: like 1, in addition using distance inequalities (default)
%
% Copyright 2012, Zhen Qin and Christian R. Shelton
% Provided free for non-commercial use
% WITHOUT ANY WARRANTY -- see Readme.txt

tic
if nargin < 3 method = 0; end   %use 0 as default

distmat=zeros(NumofTr,K);
distmat_new=zeros(NumofTr,K);


%[n,dim] = size(data);
n=NumofTr; %# of tracklets
centers = Centres;
mincenter = zeros(n,1);  %assignment?
%total = 0;
%[k,dim2] = size(centers);    

%if dim ~= dim2 error('dim(data) ~= dim(centers)'); end;


nchanged = n;
iteration = 0;
oldmincenter = zeros(n,1);

while nchanged > 0
    % do one E step, then one M step
    %computed = 0;
    
    if method == 0
        for i = 1:n
            for k = 1:K

                 distmat(i,k) = WEIGHT*mycalcdist_new(data(i),centers(:,2*k-1),centers(:,2*k),StartFrame,Width,Height);  %%%%!!!!!!!!!!!distance
                 tmpj=0;
                 for j=1:n
                     tmpj=tmpj+u(i,j,k)*psi(i,j)-u(j,i,k)*psi(j,i);
                 end
                 distmat_new(i,k) = distmat(i,k)+tmpj;
            end
        end
        [mindist,mincenter] = min(distmat_new,[],2);  %mincenter return the colomns the rows assigned to, both column vector
   

    end % if method
        
% M step: recalculate the means for each cluster    
    diff = find(mincenter ~= oldmincenter);
    
    GTracklets1=cell(K,1);
    for i=1:K
        tmp_track=(find(mincenter==i))';
        GTracklets1(i)={tmp_track};
    end
    
    centers = Centre_Gen_Town(GTracklets1,Rows,K,Data,FinishFrame,StartFrame,NumofTr,data,Width,Height);

    
    nchanged = size(diff,1);
    iteration = iteration+1;
    oldmincenter = mincenter;
    Assign=mincenter;
%   difference = max(max(abs(oldcenters - centers)));
%   [iteration toc nchanged computed size(diffj,2)]
    %[iteration toc nchanged computed]
    %total = total + computed;
end % while nchanged > 0

Centre_new=centers;



